
/**
 * /!\ This file is automatically generated by QLALR from LGCOutputLogLexer.g.
 * /!\ Don't edit it!
 */

#include "LGCOutputLogLexer.hpp"

#include "LGCMeasures.hpp"

#include <QRegularExpression>

void LGCOutputLogLexer::consumeRule(int rule)
{
	switch(rule)
	{

	case 4:
		addStyle(_currentLine.length(), Styles::Error);
		break;

	case 13:
		// Add indication for the entire line
		
		addIndication(editor(), TextIndicator::EXTERNAL, _currentLine.position(), _currentLine.length() - 1, LGCMeasures::encodeIndicator(sym(4).toUInt(), true));
		break;

	case 14:
		addIndicationSym(TextIndicator::EXTERNAL, 6, LGCMeasures::encodeIndicator(sym(6).toUInt(), true));
		addIndicationSym(TextIndicator::EXTERNAL, 8, LGCMeasures::encodeIndicator(sym(8).toUInt(), true));
		break;

	} // of the switch
}

int LGCOutputLogLexer::nextToken(QStringRef value)
{
	static const QRegularExpression numericrgx = ([]() -> QRegularExpression {
		QRegularExpression rgx(R"""(^-?[[:digit:]]*\.?[[:digit:]]+$)""");
		rgx.optimize();
		return rgx;
	})();
	
	QStringRef tval = value.trimmed();
	if (tval.isEmpty())
		return LGCOutputLogLexer::WORD;

	// integer
	if (numericrgx.match(tval).hasMatch())
	{
		bool ok;
		tval.toInt(&ok);
		if (ok)
			return LGCOutputLogLexer::INTEGER;
	}

	// keywords
	// If ERROR line
	if (_currentLine.startsWith(LGCOutputLogLexer::spell[LGCOutputLogLexer::ERROR]))
	{
		if (value.position() == _currentLine.position())
			return LGCOutputLogLexer::ERROR;
		// In line
		if (tval == LGCOutputLogLexer::spell[LGCOutputLogLexer::LINE])
			return LGCOutputLogLexer::LINE;
		if (tval == LGCOutputLogLexer::spell[LGCOutputLogLexer::FRAMES])
			return LGCOutputLogLexer::FRAMES;
	}

	return LGCOutputLogLexer::WORD;
}
